// third_party/blink/public/mojom/webid/digital_identity_request.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_DIGITAL_IDENTITY_REQUEST_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_DIGITAL_IDENTITY_REQUEST_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/webid/digital_identity_request.mojom-features.h"
#include "third_party/blink/public/mojom/webid/digital_identity_request.mojom-shared.h"
#include "third_party/blink/public/mojom/webid/digital_identity_request.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class DigitalIdentityRequestProxy;

template <typename ImplRefTraits>
class DigitalIdentityRequestStub;

class DigitalIdentityRequestRequestValidator;
class DigitalIdentityRequestResponseValidator;


class BLINK_COMMON_EXPORT DigitalIdentityRequest
    : public DigitalIdentityRequestInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DigitalIdentityRequestInterfaceBase;
  using Proxy_ = DigitalIdentityRequestProxy;

  template <typename ImplRefTraits>
  using Stub_ = DigitalIdentityRequestStub<ImplRefTraits>;

  using RequestValidator_ = DigitalIdentityRequestRequestValidator;
  using ResponseValidator_ = DigitalIdentityRequestResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestMinVersion = 0,
    kAbortMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Request_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Abort_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~DigitalIdentityRequest() = default;


  using RequestCallback = base::OnceCallback<void(RequestDigitalIdentityStatus, const std::optional<std::string>&)>;
  
  virtual void Request(DigitalCredentialProviderPtr digital_credential_provider, RequestCallback callback) = 0;

  
  virtual void Abort() = 0;
};



class BLINK_COMMON_EXPORT DigitalIdentityRequestProxy
    : public DigitalIdentityRequest {
 public:
  using InterfaceType = DigitalIdentityRequest;

  explicit DigitalIdentityRequestProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Request(DigitalCredentialProviderPtr digital_credential_provider, RequestCallback callback) final;
  
  void Abort() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT DigitalIdentityRequestStubDispatch {
 public:
  static bool Accept(DigitalIdentityRequest* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DigitalIdentityRequest* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DigitalIdentityRequest>>
class DigitalIdentityRequestStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DigitalIdentityRequestStub() = default;
  ~DigitalIdentityRequestStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalIdentityRequestStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalIdentityRequestStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT DigitalIdentityRequestRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DigitalIdentityRequestResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};







class BLINK_COMMON_EXPORT DigitalCredentialFieldRequirement {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DigitalCredentialFieldRequirement, T>::value>;
  using DataView = DigitalCredentialFieldRequirementDataView;
  using Data_ = internal::DigitalCredentialFieldRequirement_Data;

  template <typename... Args>
  static DigitalCredentialFieldRequirementPtr New(Args&&... args) {
    return DigitalCredentialFieldRequirementPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DigitalCredentialFieldRequirementPtr From(const U& u) {
    return mojo::TypeConverter<DigitalCredentialFieldRequirementPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DigitalCredentialFieldRequirement>::Convert(*this);
  }


  DigitalCredentialFieldRequirement();

  DigitalCredentialFieldRequirement(
      const std::string& name,
      const std::optional<std::string>& equals);


  ~DigitalCredentialFieldRequirement();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DigitalCredentialFieldRequirementPtr>
  DigitalCredentialFieldRequirementPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DigitalCredentialFieldRequirement::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DigitalCredentialFieldRequirement::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DigitalCredentialFieldRequirement_UnserializedMessageContext<
            UserType, DigitalCredentialFieldRequirement::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DigitalCredentialFieldRequirement::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DigitalCredentialFieldRequirement::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DigitalCredentialFieldRequirement_UnserializedMessageContext<
            UserType, DigitalCredentialFieldRequirement::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DigitalCredentialFieldRequirement::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string name;
  
  std::optional<std::string> equals;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class BLINK_COMMON_EXPORT DigitalCredentialProvider {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DigitalCredentialProvider, T>::value>;
  using DataView = DigitalCredentialProviderDataView;
  using Data_ = internal::DigitalCredentialProvider_Data;

  template <typename... Args>
  static DigitalCredentialProviderPtr New(Args&&... args) {
    return DigitalCredentialProviderPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DigitalCredentialProviderPtr From(const U& u) {
    return mojo::TypeConverter<DigitalCredentialProviderPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DigitalCredentialProvider>::Convert(*this);
  }


  DigitalCredentialProvider();

  DigitalCredentialProvider(
      const std::optional<base::flat_map<std::string, std::string>>& params,
      DigitalCredentialSelectorPtr selector,
      const std::optional<std::string>& protocol,
      const std::optional<std::string>& request,
      const std::optional<std::string>& publicKey);

DigitalCredentialProvider(const DigitalCredentialProvider&) = delete;
DigitalCredentialProvider& operator=(const DigitalCredentialProvider&) = delete;

  ~DigitalCredentialProvider();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DigitalCredentialProviderPtr>
  DigitalCredentialProviderPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DigitalCredentialProvider::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DigitalCredentialProvider::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DigitalCredentialProvider_UnserializedMessageContext<
            UserType, DigitalCredentialProvider::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DigitalCredentialProvider::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DigitalCredentialProvider::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DigitalCredentialProvider_UnserializedMessageContext<
            UserType, DigitalCredentialProvider::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DigitalCredentialProvider::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<base::flat_map<std::string, std::string>> params;
  
  DigitalCredentialSelectorPtr selector;
  
  std::optional<std::string> protocol;
  
  std::optional<std::string> request;
  
  std::optional<std::string> publicKey;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT DigitalCredentialSelector {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DigitalCredentialSelector, T>::value>;
  using DataView = DigitalCredentialSelectorDataView;
  using Data_ = internal::DigitalCredentialSelector_Data;

  template <typename... Args>
  static DigitalCredentialSelectorPtr New(Args&&... args) {
    return DigitalCredentialSelectorPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DigitalCredentialSelectorPtr From(const U& u) {
    return mojo::TypeConverter<DigitalCredentialSelectorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DigitalCredentialSelector>::Convert(*this);
  }


  DigitalCredentialSelector();

  DigitalCredentialSelector(
      std::vector<std::string> format,
      const std::optional<std::string>& doctype,
      std::vector<DigitalCredentialFieldRequirementPtr> fields);

DigitalCredentialSelector(const DigitalCredentialSelector&) = delete;
DigitalCredentialSelector& operator=(const DigitalCredentialSelector&) = delete;

  ~DigitalCredentialSelector();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DigitalCredentialSelectorPtr>
  DigitalCredentialSelectorPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DigitalCredentialSelector::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DigitalCredentialSelector::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DigitalCredentialSelector_UnserializedMessageContext<
            UserType, DigitalCredentialSelector::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DigitalCredentialSelector::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DigitalCredentialSelector::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DigitalCredentialSelector_UnserializedMessageContext<
            UserType, DigitalCredentialSelector::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DigitalCredentialSelector::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<std::string> format;
  
  std::optional<std::string> doctype;
  
  std::vector<DigitalCredentialFieldRequirementPtr> fields;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}


template <typename StructPtrType>
DigitalCredentialProviderPtr DigitalCredentialProvider::Clone() const {
  return New(
      mojo::Clone(params),
      mojo::Clone(selector),
      mojo::Clone(protocol),
      mojo::Clone(request),
      mojo::Clone(publicKey)
  );
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>*>
bool DigitalCredentialProvider::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->params, other_struct.params))
    return false;
  if (!mojo::Equals(this->selector, other_struct.selector))
    return false;
  if (!mojo::Equals(this->protocol, other_struct.protocol))
    return false;
  if (!mojo::Equals(this->request, other_struct.request))
    return false;
  if (!mojo::Equals(this->publicKey, other_struct.publicKey))
    return false;
  return true;
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.params < rhs.params)
    return true;
  if (rhs.params < lhs.params)
    return false;
  if (lhs.selector < rhs.selector)
    return true;
  if (rhs.selector < lhs.selector)
    return false;
  if (lhs.protocol < rhs.protocol)
    return true;
  if (rhs.protocol < lhs.protocol)
    return false;
  if (lhs.request < rhs.request)
    return true;
  if (rhs.request < lhs.request)
    return false;
  if (lhs.publicKey < rhs.publicKey)
    return true;
  if (rhs.publicKey < lhs.publicKey)
    return false;
  return false;
}
template <typename StructPtrType>
DigitalCredentialSelectorPtr DigitalCredentialSelector::Clone() const {
  return New(
      mojo::Clone(format),
      mojo::Clone(doctype),
      mojo::Clone(fields)
  );
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>*>
bool DigitalCredentialSelector::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->format, other_struct.format))
    return false;
  if (!mojo::Equals(this->doctype, other_struct.doctype))
    return false;
  if (!mojo::Equals(this->fields, other_struct.fields))
    return false;
  return true;
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.format < rhs.format)
    return true;
  if (rhs.format < lhs.format)
    return false;
  if (lhs.doctype < rhs.doctype)
    return true;
  if (rhs.doctype < lhs.doctype)
    return false;
  if (lhs.fields < rhs.fields)
    return true;
  if (rhs.fields < lhs.fields)
    return false;
  return false;
}
template <typename StructPtrType>
DigitalCredentialFieldRequirementPtr DigitalCredentialFieldRequirement::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(equals)
  );
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>*>
bool DigitalCredentialFieldRequirement::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->equals, other_struct.equals))
    return false;
  return true;
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.equals < rhs.equals)
    return true;
  if (rhs.equals < lhs.equals)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::DigitalCredentialProvider::DataView,
                                         ::blink::mojom::DigitalCredentialProviderPtr> {
  static bool IsNull(const ::blink::mojom::DigitalCredentialProviderPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::DigitalCredentialProviderPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::DigitalCredentialProvider::params)& params(
      const ::blink::mojom::DigitalCredentialProviderPtr& input) {
    return input->params;
  }

  static const decltype(::blink::mojom::DigitalCredentialProvider::selector)& selector(
      const ::blink::mojom::DigitalCredentialProviderPtr& input) {
    return input->selector;
  }

  static const decltype(::blink::mojom::DigitalCredentialProvider::protocol)& protocol(
      const ::blink::mojom::DigitalCredentialProviderPtr& input) {
    return input->protocol;
  }

  static const decltype(::blink::mojom::DigitalCredentialProvider::request)& request(
      const ::blink::mojom::DigitalCredentialProviderPtr& input) {
    return input->request;
  }

  static const decltype(::blink::mojom::DigitalCredentialProvider::publicKey)& publicKey(
      const ::blink::mojom::DigitalCredentialProviderPtr& input) {
    return input->publicKey;
  }

  static bool Read(::blink::mojom::DigitalCredentialProvider::DataView input, ::blink::mojom::DigitalCredentialProviderPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::DigitalCredentialSelector::DataView,
                                         ::blink::mojom::DigitalCredentialSelectorPtr> {
  static bool IsNull(const ::blink::mojom::DigitalCredentialSelectorPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::DigitalCredentialSelectorPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::DigitalCredentialSelector::format)& format(
      const ::blink::mojom::DigitalCredentialSelectorPtr& input) {
    return input->format;
  }

  static const decltype(::blink::mojom::DigitalCredentialSelector::doctype)& doctype(
      const ::blink::mojom::DigitalCredentialSelectorPtr& input) {
    return input->doctype;
  }

  static const decltype(::blink::mojom::DigitalCredentialSelector::fields)& fields(
      const ::blink::mojom::DigitalCredentialSelectorPtr& input) {
    return input->fields;
  }

  static bool Read(::blink::mojom::DigitalCredentialSelector::DataView input, ::blink::mojom::DigitalCredentialSelectorPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::DigitalCredentialFieldRequirement::DataView,
                                         ::blink::mojom::DigitalCredentialFieldRequirementPtr> {
  static bool IsNull(const ::blink::mojom::DigitalCredentialFieldRequirementPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::DigitalCredentialFieldRequirementPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::DigitalCredentialFieldRequirement::name)& name(
      const ::blink::mojom::DigitalCredentialFieldRequirementPtr& input) {
    return input->name;
  }

  static const decltype(::blink::mojom::DigitalCredentialFieldRequirement::equals)& equals(
      const ::blink::mojom::DigitalCredentialFieldRequirementPtr& input) {
    return input->equals;
  }

  static bool Read(::blink::mojom::DigitalCredentialFieldRequirement::DataView input, ::blink::mojom::DigitalCredentialFieldRequirementPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_DIGITAL_IDENTITY_REQUEST_MOJOM_H_