// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_provider_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"domainHint",
"loginHint",
"nonce",
"params",
"responseType",
"scope",
};


}  // namespace 

IdentityProviderRequestOptions* IdentityProviderRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  IdentityProviderRequestOptions* dictionary = MakeGarbageCollected<IdentityProviderRequestOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "IdentityProviderRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 IdentityProviderRequestOptions::IdentityProviderRequestOptions() {
  
}

 IdentityProviderRequestOptions::IdentityProviderRequestOptions(v8::Isolate* isolate) : IdentityProviderConfig(isolate) {
  
}



String IdentityProviderRequestOptions::getDomainHintOr(const String& fallback_value) const {
  if (!hasDomainHint()) {
  return fallback_value;
}
return member_domain_hint_;
}

String IdentityProviderRequestOptions::getDomainHintOr(String&& fallback_value) const {
  if (!hasDomainHint()) {
  return std::move(fallback_value);
}
return member_domain_hint_;
}

void IdentityProviderRequestOptions::setDomainHint(const String& value) {
  member_domain_hint_ = value;
has_domain_hint_ = true;
}

void IdentityProviderRequestOptions::setDomainHint(String&& value) {
  member_domain_hint_ = std::move(value);
has_domain_hint_ = true;
}




String IdentityProviderRequestOptions::getLoginHintOr(const String& fallback_value) const {
  if (!hasLoginHint()) {
  return fallback_value;
}
return member_login_hint_;
}

String IdentityProviderRequestOptions::getLoginHintOr(String&& fallback_value) const {
  if (!hasLoginHint()) {
  return std::move(fallback_value);
}
return member_login_hint_;
}

void IdentityProviderRequestOptions::setLoginHint(const String& value) {
  member_login_hint_ = value;
has_login_hint_ = true;
}

void IdentityProviderRequestOptions::setLoginHint(String&& value) {
  member_login_hint_ = std::move(value);
has_login_hint_ = true;
}




String IdentityProviderRequestOptions::getNonceOr(const String& fallback_value) const {
  if (!hasNonce()) {
  return fallback_value;
}
return member_nonce_;
}

String IdentityProviderRequestOptions::getNonceOr(String&& fallback_value) const {
  if (!hasNonce()) {
  return std::move(fallback_value);
}
return member_nonce_;
}

void IdentityProviderRequestOptions::setNonce(const String& value) {
  member_nonce_ = value;
has_nonce_ = true;
}

void IdentityProviderRequestOptions::setNonce(String&& value) {
  member_nonce_ = std::move(value);
has_nonce_ = true;
}




Vector<std::pair<String, String>> IdentityProviderRequestOptions::getParamsOr(const Vector<std::pair<String, String>>& fallback_value) const {
  if (!hasParams()) {
  return fallback_value;
}
return member_params_;
}

Vector<std::pair<String, String>> IdentityProviderRequestOptions::getParamsOr(Vector<std::pair<String, String>>&& fallback_value) const {
  if (!hasParams()) {
  return std::move(fallback_value);
}
return member_params_;
}

void IdentityProviderRequestOptions::setParams(const Vector<std::pair<String, String>>& value) {
  member_params_ = value;
has_params_ = true;
}

void IdentityProviderRequestOptions::setParams(Vector<std::pair<String, String>>&& value) {
  member_params_ = std::move(value);
has_params_ = true;
}




Vector<String> IdentityProviderRequestOptions::getResponseTypeOr(const Vector<String>& fallback_value) const {
  if (!hasResponseType()) {
  return fallback_value;
}
return member_response_type_;
}

Vector<String> IdentityProviderRequestOptions::getResponseTypeOr(Vector<String>&& fallback_value) const {
  if (!hasResponseType()) {
  return std::move(fallback_value);
}
return member_response_type_;
}

void IdentityProviderRequestOptions::setResponseType(const Vector<String>& value) {
  member_response_type_ = value;
has_response_type_ = true;
}

void IdentityProviderRequestOptions::setResponseType(Vector<String>&& value) {
  member_response_type_ = std::move(value);
has_response_type_ = true;
}




Vector<String> IdentityProviderRequestOptions::getScopeOr(const Vector<String>& fallback_value) const {
  if (!hasScope()) {
  return fallback_value;
}
return member_scope_;
}

Vector<String> IdentityProviderRequestOptions::getScopeOr(Vector<String>&& fallback_value) const {
  if (!hasScope()) {
  return std::move(fallback_value);
}
return member_scope_;
}

void IdentityProviderRequestOptions::setScope(const Vector<String>& value) {
  member_scope_ = value;
has_scope_ = true;
}

void IdentityProviderRequestOptions::setScope(Vector<String>&& value) {
  member_scope_ = std::move(value);
has_scope_ = true;
}




void IdentityProviderRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_domain_hint_);
TraceIfNeeded<String>::Trace(visitor, member_login_hint_);
TraceIfNeeded<String>::Trace(visitor, member_nonce_);
TraceIfNeeded<Vector<std::pair<String, String>>>::Trace(visitor, member_params_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_response_type_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_scope_);
IdentityProviderConfig::Trace(visitor);
}

void IdentityProviderRequestOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  IdentityProviderConfig::FillTemplateProperties(properties);
DCHECK_EQ(properties.size(), kBasePropertyCount);

static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void IdentityProviderRequestOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  IdentityProviderConfig::FillValuesImpl(script_state, values.first(kBasePropertyCount));
values = values.subspan(kBasePropertyCount);

CHECK_EQ(kOwnPropertyCount, values.size());
if (RuntimeEnabledFeatures::FedCmDomainHintEnabled()) {
  if (hasDomainHint()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_domain_hint_);
DCHECK(!values[0].IsEmpty());
}
}
if (hasLoginHint()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_login_hint_);
DCHECK(!values[1].IsEmpty());
}
if (hasNonce()) {
  values[2] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_nonce_);
DCHECK(!values[2].IsEmpty());
}
if (RuntimeEnabledFeatures::FedCmAuthzEnabled()) {
  if (hasParams()) {
  values[3] = ToV8Traits<IDLRecord<IDLUSVString, IDLUSVString>>::ToV8(script_state, member_params_);
DCHECK(!values[3].IsEmpty());
}
}
if (RuntimeEnabledFeatures::FedCmAuthzEnabled()) {
  if (hasResponseType()) {
  values[4] = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_response_type_);
DCHECK(!values[4].IsEmpty());
}
}
if (RuntimeEnabledFeatures::FedCmAuthzEnabled()) {
  if (hasScope()) {
  values[5] = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_scope_);
DCHECK(!values[5].IsEmpty());
}
}
}

const void* IdentityProviderRequestOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> IdentityProviderRequestOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void IdentityProviderRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  IdentityProviderConfig::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "IdentityProviderRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::FedCmDomainHintEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("domainHint");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_domain_hint_, member_domain_hint_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("loginHint");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_login_hint_, member_login_hint_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("nonce");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_nonce_, member_nonce_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FedCmAuthzEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("params");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_params_, member_params_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::FedCmAuthzEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("responseType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_response_type_, member_response_type_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::FedCmAuthzEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("scope");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_scope_, member_scope_, try_block, exception_state)) {
  return;
}
}
}

const base::span<const v8::Eternal<v8::Name>> IdentityProviderRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
